#include "event_loop.h"

event_loop_gctx *event_loop_gctx_init() {
  event_loop_gctx *gctx = calloc(sizeof(event_loop_gctx), 1);

  return gctx;
}

event_loop_ctx *event_loop_ctx_init(event_loop_gctx *g) {
  event_loop_ctx *ctx = calloc(sizeof(event_loop_ctx), 1);
  ctx->g = g;

  return ctx;
}

void event_loop_ctx_free(event_loop_ctx *ctx) { free(ctx); }

event_loop_conn *event_loop_conn_init(event_loop_gctx *g) {
  event_loop_conn *conn = calloc(sizeof(event_loop_conn), 1);
  conn->ctx = event_loop_ctx_init(g);

  return conn;
}

void event_loop_conn_free(event_loop_conn *conn) {
  event_loop_ctx_free(conn->ctx);
  free(conn);
}
